public class EVListe<T> {

    private class Item {
        T    elem;
	Item next;
    }

    private Item first;
    private Item last;

    public EVListe() {
        this.first = null;
	this.last = null;
    }

    public void append(T elem) {
        Item item = new Item();

	item.next = null;
	item.elem = elem;

	if ( this.first == null ) {
	    this.first = item;
	}
	else {
	    this.last.next = item;
	}
	this.last = item;
    }

    public void insert(T elem) {		// Aufgabe (a): Einfuegen vor dem ersten Element
        Item item = new Item();			// neues Hilfsobjekt
	
	item.next = this.first;			// aktuell Erstes wird Nachfolger von neuem Ersten
	item.elem = elem;			// Element in Hilfsobjekt ablegen

	this.first = item;			// Hilfselement ist neues Erstes
	if ( this.last == null ) {		// Wenn Liste bisher leer,
	    this.last = item;			// dann ist Hilfselement auch neues Letztes
	}
    }

    public T getFirst() {
        return this.first.elem;
    }

    public void remove() {
        this.first = this.first.next;
        if ( this.first == null ) {
	    this.last = null;
	}
    }

    public void remove2() {			// Aufgabe (b): zweites Listenelement loeschen
        Item third = this.first.next.next;	// Drittes ist der Nachfolger vom Nachfolger vom Ersten

        this.first.next = third;		// Das Dritte wird neuer Nachfolger vom Ersten
	if ( third == null ) {			// Wenn die Liste bisher zur zwei Elemente hatte,
	    this.last = this.first;		// dann hat sie jetzt nur noch ein Element und
	}					// das Erste ist auch das neue Letzte.
    }

    public void remove(int k) {			// Aufgabe (c): k-tes Element loeschen (Index ab 0)
        Item item = this.first;			// k-tes Hilfsobjekt: Initialiserung fuer die Suche
	Item pred = null;			// (k-1)-tes Hilfsobjekt
	Item succ;				// (k+1)-tes Hilfsobjekt

	for( int i=0 ; i<k ; i++) {		// Suche k-tes Hilfsobjekt
	    pred = item;			// pred bleibt stets Vorgaenger von item
	    item = item.next;
	}
	succ = item.next;			// (k+1)-tes Hilfsobjekt setzen

	if ( pred==null ) {			// Wenn zu loeschendes k-tes das Erste ist,
	    this.first = succ;			// dann ist (k+1)-tes das neue Erste,
	}
	else {					// ansonsten wird
	    pred.next = succ;			// das (k+1)-te der Nachfolger vom (k-1)-ten.
        }

	if ( succ == null ) {			// Wenn zu loeschendes k-tes das Letzte ist,
	    this.last = pred;			// dann ist das (k-1)-te das neue Letzte.
	}
    }

    public int size() {				// Aufgabe (d): Anzahl der Listenelemente ermitteln
        Item item = first;			// angefangen beim ersten Listenelement
	int  n = 0;

	while ( item != null ) {		// zaehlen wir alle Elemente durch
	    n++;
	    item = item.next;
	}

	return n;
    }

    public int sizeR() {			// Aufgabe (e) Anzahl der Listenelemente rekursiv ermitteln
        return this.sizeR(first);		// nutze rekursive private Hilfsmethode
    }

    private int sizeR(Item item) {		// wie viele Elemente ab (inklusive) item?
    						// Wenn item == null, dann 0,
						// ansonsten 1 + Anzahl ab Nachfolger von item.
	return item==null ? 0 : 1 + this.sizeR(item.next);
    }
}
